## kdevelop 25.08.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Gear version, managed by release service script
set(RELEASE_SERVICE_VERSION_MAJOR "25")
set(RELEASE_SERVICE_VERSION_MINOR "08")
set(RELEASE_SERVICE_VERSION_MICRO "2")

set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# generate patch level from release service version
set(_micro ${RELEASE_SERVICE_VERSION_MICRO})
if (_micro LESS "10")
    string(PREPEND _micro "0") # pad with 0
endif()
set(RELEASE_SERVICE_BASED_PATCHLEVEL "${RELEASE_SERVICE_VERSION_MAJOR}${RELEASE_SERVICE_VERSION_MINOR}${_micro}")

# The math expression below automatically increments KDevelop minor version in each KDE Gear release.
# The multiplier 3 is the number of releases that share ${RELEASE_SERVICE_VERSION_MAJOR}.
# The fraction assigns consecutive minor versions to the 3 releases - 04, 08 and 12. The rounding up groups
# pre-release versions with the corresponding final release versions: 03 with 04, 07 with 08 and 11 with 12.
# The final subtrahend at the end of the expression ensures version continuity: KDevelop 6.0 in KDE Gear 24.08.
math(EXPR KDEVELOP_OWN_MINOR_VERSION "${RELEASE_SERVICE_VERSION_MAJOR} * 3                  \
                                      + (${RELEASE_SERVICE_VERSION_MINOR} + 4 - 3) / 4      \
                                      - 74")

# On macOS KDevelop_VERSION_MINOR is modified below. But KDEV_ITEMREPOSITORY_VERSION should depend on the
# original minor version on all platforms. So the variable ${KDEVELOP_OWN_MINOR_VERSION} is used again later.
project(KDevelop VERSION "6.${KDEVELOP_OWN_MINOR_VERSION}.${RELEASE_SERVICE_BASED_PATCHLEVEL}")

# KDevelop SOVERSION
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVELOP_SOVERSION "${KDevelop_VERSION_MAJOR}${KDevelop_VERSION_MINOR}")

if (APPLE)
    ###################################################################################
    # Kludge for bug #448152: ld: malformed 64-bit a.b.c.d.e version number: 5.7.211201
    # Apple's linker uses the project version (not the SOVERSION) to calculate an
    # unsigned int in such a way that places restrictions on the magnitude of each tier
    # of the version string.
    # See here: https://www.sicpers.info/2013/03/how-to-version-a-mach-o-library/
    ###################################################################################
    project(KDevelop VERSION "${KDevelop_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${_micro}")
endif()

# plugin version as used e.g. in plugin installation path
set(KDEV_PLUGIN_VERSION "${KDEVELOP_SOVERSION}")

set(QT_MIN_VERSION "6.5.0")
set(KF_MIN_VERSION "6.0.0")

option(BUILD_DOC "Whether to build the documentation" ON)

# we need some parts of the ECM CMake helpers
find_package (ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevelop_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE) # needs to be first, as set policies influence following macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(KDevelopMacrosInternal)

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS
    Concurrent
    Core5Compat
    DBus
    Quick
    QuickWidgets
    Widgets
)
if(BUILD_TESTING)
  find_package(Qt6Test ${QT_MIN_VERSION} REQUIRED)
endif()

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
  Config
  IconThemes
  I18n
  ItemModels
  ItemViews
  JobWidgets
  KCMUtils
  KIO
  NewStuff
  NotifyConfig
  Parts
  Service
  TextEditor
  ThreadWeaver
  XmlGui
  WindowSystem
  Crash
  GuiAddons
  Archive
  Notifications
  Sonnet
  TextTemplate
  TextWidgets
)
if(BUILD_DOC)
    find_package(KF6DocTools ${KF_MIN_VERSION} REQUIRED)
    set_package_properties(KF6DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif()

set(HAVE_KSYSGUARD FALSE)
find_package(KSysGuard CONFIG QUIET)
set_package_properties(KSysGuard PROPERTIES
    PURPOSE "Framework for process listing. Required for the 'Attach to Process' feature"
    TYPE RECOMMENDED
)
if(KSysGuard_FOUND)
    set(HAVE_KSYSGUARD TRUE)
endif()

find_package(KDevelopPGQt 2.4 QUIET) # TODO (once we require KDevelopPGQt version 2.4 or later): remove QUIET again
set_package_properties(KDevelopPGQt PROPERTIES
    PURPOSE "KDevelop parser generator library. Required for the QMake Builder/Manager plugin."
    TYPE RECOMMENDED
)
if (NOT KDevelopPGQt_FOUND)
    find_package(KDevelop-PG-Qt 2.3)
    set_package_properties(KDevelop-PG-Qt PROPERTIES
        PURPOSE "KDevelop parser generator library (older name & version). Required for the QMake Builder/Manager plugin."
        TYPE RECOMMENDED
    )
endif()

find_package(SharedMimeInfo 1.9 REQUIRED)

# added by KDE_COMPILERSETTINGS_LEVEL 5.85.0
remove_definitions(
    -DQT_NO_KEYWORDS
)
add_definitions(
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
)
ecm_set_disabled_deprecation_versions(
    DISABLE_NEWER_WARNINGS # remove again once Qt6/KF6 porting work fully done
    QT ${QT_MIN_VERSION}
    KF ${KF_MIN_VERSION}
)

# Globally enable PIC since static libraries need it for Qt staticMetaObject
# Furthermore, without that we cannot easily compile with ASAN either
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Turn off missing-field-initializers warning for GCC to avoid noise from false positives with empty {}
# See discussion: https://mail.kde.org/pipermail/kdevelop-devel/2014-February/046910.html
add_compile_flag_if_supported(-Wno-missing-field-initializers)
add_compile_flag_if_supported(-Werror=switch)
add_compile_flag_if_supported(-Werror=undefined-bool-conversion)
add_compile_flag_if_supported(-Werror=tautological-undefined-compare)
add_compile_flag_if_supported(-Werror=implicit-fallthrough)    # Use [[fallthrough]] for false positives.
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-Wdocumentation)
    add_compile_flag_if_supported(-Wcovered-switch-default)
    add_compile_flag_if_supported(-Wunreachable-code-break)
    # This warning is triggered by every call to qCDebug()
    add_compile_flag_if_supported(-Wno-gnu-zero-variadic-macro-arguments)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-pedantic)
    add_compile_flag_if_supported(-Wzero-as-null-pointer-constant CXX_ONLY)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_compile_flag_if_supported(-Wsuggest-override CXX_ONLY)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if(CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug"
  OR CMAKE_BUILD_TYPE_TOLOWER STREQUAL "")
  set(COMPILER_OPTIMIZATIONS_ENABLED OFF)
else()
  set(COMPILER_OPTIMIZATIONS_ENABLED ON)
endif()

option(BUILD_BENCHMARKS "Whether benchmarks should be compiled or not" ${COMPILER_OPTIMIZATIONS_ENABLED})

# create config-kdevelop.h
configure_file(config-kdevelop.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kdevelop.h)
include_directories(${KDevelop_BINARY_DIR}) # for config-kdevelop.h

add_subdirectory(3rdparty/timsort)

add_subdirectory(kdevplatform)
add_subdirectory(plugins)

add_subdirectory(pics)
add_subdirectory(app)
add_subdirectory(app_templates)
add_subdirectory(file_templates)
add_subdirectory(shortcuts)
add_subdirectory(share)

if(BUILD_DOC)
    add_subdirectory(doc)
    kdoctools_install(po)
endif()

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop")
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevelopConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
                                  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)
ecm_setup_version(PROJECT
                  VARIABLE_PREFIX KDEVELOP
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevelop")
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install(EXPORT KDevelopTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" NAMESPACE KDev:: FILE KDevelopTargets.cmake)

# kdebugsettings file
install_qt_logging_categories(TYPE APP_PLUGIN)

install(FILES org.kde.kdevelop.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

# Make it possible to use the po files fetched by the fetch-translations step
ki18n_install(po)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== 3rdparty/timsort/CMakeLists.txt ===
add_library(gfx_timsort INTERFACE)
add_library(gfx::timsort ALIAS gfx_timsort)
target_include_directories(gfx_timsort INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/..")

=== kdevplatform/tests/CMakeLists.txt ===
configure_file("sourcefilepaths.h.cmake" "sourcefilepaths.h" ESCAPE_QUOTES)

set(kdevtests_LIB_SRCS
    autotestshell.cpp
    kdevsignalspy.cpp
    plugintesthelpers.cpp
    projectsgenerator.cpp
    testcore.cpp
    testproject.cpp
    testfile.cpp
    testlanguagecontroller.cpp
    testhelpers.cpp
    testplugincontroller.cpp
    testdebugsession.cpp
    testvariablecontroller.cpp
    testbreakpointcontroller.cpp
    testframestackmodel.cpp

    json/delayedoutput.cpp
    json/declarationvalidator.cpp
    json/testsuite.cpp
)

kdevplatform_add_library(KDevPlatformTests SOURCES ${kdevtests_LIB_SRCS})
target_link_libraries(KDevPlatformTests
PUBLIC
    KDev::Shell
    KDev::Language
    KDev::Project
    KDev::Debugger
PRIVATE
    Qt::Test
)

install(FILES
    autotestshell.h
    corelesshelpers.h
    kdevsignalspy.h
    plugintesthelpers.h
    projectsgenerator.h
    testcore.h
    testproject.h
    testfile.h
    testlanguagecontroller.h
    testhelpermacros.h
    testhelpers.h
    testplugincontroller.h
    testdebugsession.h
    testvariablecontroller.h
    testbreakpointcontroller.h
    testframestackmodel.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/tests/
    COMPONENT Devel
)

install(FILES
    json/declarationvalidator.h
    json/delayedoutput.h
    json/jsontesthelpers.h
    json/testsuite.h
    json/testsuite.cpp
    json/jsondeclarationtests.h
    json/jsonducontexttests.h
    json/jsontypetests.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/tests/json
    COMPONENT Devel
)

=== plugins/appwizard/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevappwizard\")

########### next target ###############

set(kdevappwizard_PART_SRCS
    appwizardplugin.cpp
    appwizarddialog.cpp
    appwizardpagewidget.cpp
    projectselectionpage.cpp
    projecttemplatesmodel.cpp
    projectvcspage.cpp
)

set(kdevappwizard_PART_UI
    projectselectionpage.ui
    projectvcspage.ui
)

declare_qt_logging_category(kdevappwizard_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_APPWIZARD
    CATEGORY_BASENAME "appwizard"
)

ki18n_wrap_ui(kdevappwizard_PART_SRCS ${kdevappwizard_PART_UI})

install(FILES kdevappwizard.knsrc  DESTINATION ${KDE_INSTALL_KNSRCDIR})
qt_add_resources(kdevappwizard_PART_SRCS kdevappwizard.qrc)
kdevplatform_add_plugin(kdevappwizard SOURCES ${kdevappwizard_PART_SRCS})

target_link_libraries(kdevappwizard
    KDev::Interfaces
    KDev::Vcs
    KDev::Language
    KDev::Sublime
    KDev::Util
    KF6::KIOWidgets
    KF6::NewStuffWidgets
    KF6::Archive
    Qt::Core5Compat
)

=== plugins/astyle/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevastyle\")

find_package(LibAStyle 3.1)
set_package_properties(LibAStyle PROPERTIES
    DESCRIPTION "Artistic Style library"
    PURPOSE "External library for the astyle plugin"
    URL "http://astyle.sourceforge.net/"
    TYPE RECOMMENDED)

declare_qt_logging_category(kdevastyle_LOG_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_ASTYLE
    CATEGORY_BASENAME "astyle"
)

set(kdevastyle_PART_SRCS
    astyle_plugin.cpp
    astyle_preferences.cpp
    astyle_formatter.cpp
    astyle_stringiterator.cpp
    ${kdevastyle_LOG_SRCS}
)

set(astyle_preferences_UI
    astyle_preferences.ui
)

ki18n_wrap_ui(kdevastyle_PART_SRCS ${astyle_preferences_UI} )
kdevplatform_add_plugin(kdevastyle SOURCES ${kdevastyle_PART_SRCS})
target_link_libraries(kdevastyle
    astylelib

    KF6::Parts
    KF6::KIOWidgets
    KF6::TextEditor

    KDev::Interfaces
    KDev::Util)

if(NOT LibAStyle_FOUND)
    add_subdirectory(3rdparty/libastyle)
endif()
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== plugins/cppcheck/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevcppcheck\")

find_package(Cppcheck QUIET)
set_package_properties(Cppcheck PROPERTIES
    DESCRIPTION "A tool for static C/C++ code analysis"
    URL "http://cppcheck.sourceforge.net/"
    PURPOSE "Recommended: required by the non-essential Cppcheck plugin"
    TYPE RUNTIME
)

set(kdevcppcheck_core_SRCS
    parser.cpp
    job.cpp
    parameters.cpp
    utils.cpp
)
declare_qt_logging_category(kdevcppcheck_core_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_CPPCHECK
    CATEGORY_BASENAME "cppcheck"
)
kconfig_add_kcfg_files(kdevcppcheck_core_SRCS
    config/globalsettings.kcfgc
    config/projectsettings.kcfgc
)
add_library(kdevcppcheck_core STATIC
    ${kdevcppcheck_core_SRCS}
)
target_link_libraries(kdevcppcheck_core
    KDev::Language
    KDev::Project
    KDev::Shell
    KF6::KIOWidgets
)

set(kdevcppcheck_SRCS
    plugin.cpp
    problemmodel.cpp

    config/globalconfigpage.cpp
    config/projectconfigpage.cpp
)
ki18n_wrap_ui(kdevcppcheck_SRCS
    config/globalconfigpage.ui
    config/projectconfigpage.ui
)
qt_add_resources(kdevcppcheck_SRCS
    kdevcppcheck.qrc
)
kdevplatform_add_plugin(kdevcppcheck
    SOURCES ${kdevcppcheck_SRCS}
)
target_link_libraries(kdevcppcheck
    kdevcppcheck_core
)

ecm_install_icons(ICONS icons/128-apps-cppcheck.png
                  DESTINATION ${KDE_INSTALL_ICONDIR} THEME hicolor)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== plugins/externalscript/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevexternalscript\")
########### next target ###############

set(kdevexternalscript_PART_SRCS
    externalscriptplugin.cpp
    externalscriptview.cpp
    externalscriptitem.cpp
    externalscriptjob.cpp
    editexternalscript.cpp
)

declare_qt_logging_category(kdevexternalscript_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_EXTERNALSCRIPT
    CATEGORY_BASENAME "externalscript"
)

set(kdevexternalscript_PART_UI
    externalscriptview.ui
    editexternalscript.ui
)

ki18n_wrap_ui(kdevexternalscript_PART_SRCS ${kdevexternalscript_PART_UI})

qt_add_resources(kdevexternalscript_PART_SRCS kdevexternalscript.qrc)
kdevplatform_add_plugin(kdevexternalscript SOURCES ${kdevexternalscript_PART_SRCS})

target_link_libraries(kdevexternalscript
    KDev::Language
    KDev::Interfaces
    KDev::Project
    KDev::Sublime
    KDev::Util
    KDev::OutputView
    KF6::TextEditor
    KF6::KIOWidgets
    KF6::Parts
    Qt::DBus
)

=== plugins/ghprovider/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevghprovider\")

add_subdirectory(icons)

set(kdevghprovider_PART_SRCS
    ghlineedit.cpp
    ghprovidermodel.cpp
    ghproviderplugin.cpp
    ghproviderwidget.cpp
    ghresource.cpp
    ghaccount.cpp
    ghdialog.cpp
)
declare_qt_logging_category(kdevghprovider_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER GHPROVIDER
    CATEGORY_BASENAME "ghprovider"
    DESCRIPTION "githubprovider"
)

kdevplatform_add_plugin(kdevghprovider SOURCES ${kdevghprovider_PART_SRCS})
target_link_libraries(kdevghprovider
  KF6::KIOWidgets
  KDev::Interfaces
  KDev::Vcs
  KDev::OutputView
  KDev::Util
)

=== plugins/git/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevgit\")

declare_qt_logging_category(kdevgit_LOG_PART_SRCS
    TYPE PLUGIN
    IDENTIFIER PLUGIN_GIT
    CATEGORY_BASENAME "git"
)
set(kdevgit_PART_SRCS
    repostatusmodel.cpp
    committoolview.cpp
    diffviewsctrl.cpp
    simplecommitform.cpp
    rebasedialog.cpp
    stashmanagerdialog.cpp
    stashpatchsource.cpp
    gitmessagehighlighter.cpp
    gitclonejob.cpp
    gitplugin.cpp
    gitpluginmetadata.cpp
    gitjob.cpp
    gitplugincheckinrepositoryjob.cpp
    gitnameemaildialog.cpp
    ${kdevgit_LOG_PART_SRCS}
)
ki18n_wrap_ui(kdevgit_PART_SRCS stashmanagerdialog.ui)
ki18n_wrap_ui(kdevgit_PART_SRCS gitnameemaildialog.ui)
ki18n_wrap_ui(kdevgit_PART_SRCS rebasedialog.ui)
kdevplatform_add_plugin(kdevgit SOURCES ${kdevgit_PART_SRCS})
target_link_libraries(kdevgit
    KDev::Util
    KDev::Interfaces
    KDev::Vcs
    KDev::Project
    KF6::SonnetUi
    KF6::TextWidgets
    Qt::Core5Compat
)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()
add_subdirectory(icons)

install(PROGRAMS org.kde.kdevelop_git.desktop DESTINATION ${KDE_INSTALL_APPDIR})

install(FILES kdevgit.xml DESTINATION ${KDE_INSTALL_MIMEDIR})
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})

=== kdevplatform/project/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

ecm_add_test(test_projectmodel.cpp
    LINK_LIBRARIES Qt::Test KDev::Interfaces KDev::Project KDev::Language KDev::Tests)

add_executable(projectmodelperformancetest
    projectmodelperformancetest.cpp
)
target_link_libraries(projectmodelperformancetest
    Qt::Test
    Qt::Gui
    KDev::Interfaces
    KDev::Project
    KDev::Language
    KDev::Tests
)

add_executable(abstractfilemanagerpluginimporttest
    abstractfilemanagerpluginimporttest.cpp
)
target_link_libraries(abstractfilemanagerpluginimporttest
    KDev::Project
    KDev::Tests
    Qt::QuickWidgets
)

add_executable(abstractfilemanagerpluginimportbenchmark
    abstractfilemanagerpluginimportbenchmark.cpp
)
ecm_mark_nongui_executable(abstractfilemanagerpluginimportbenchmark)
target_link_libraries(abstractfilemanagerpluginimportbenchmark
    KDev::Project
    KDev::Tests
)

=== kdevplatform/vcs/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

ecm_add_test(test_vcsrevision.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

ecm_add_test(test_vcsannotationline.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

ecm_add_test(test_vcsannotation.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

ecm_add_test(test_vcsitemevent.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

ecm_add_test(test_vcsevent.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

ecm_add_test(test_vcsstatusinfo.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

ecm_add_test(test_vcsdiff.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

ecm_add_test(test_vcslocation.cpp
    LINK_LIBRARIES Qt::Test KDev::Vcs
)

=== plugins/bazaar/icons/CMakeLists.txt ===
ecm_install_icons(ICONS 128-apps-bazaar.png
                  DESTINATION ${KDE_INSTALL_ICONDIR}
                  THEME hicolor)

=== debian/changelog ===
kdevelop (4:25.08.2-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.08.2)

 -- Rik Mills <rikmills@kde.org>  Fri, 17 Oct 2025 11:44:40 +0100

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: bash-completion,
               clang (>= 1:6.0),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-qmldeps,
               extra-cmake-modules (>= 6.0.0~),
               kdevelop-pg-qt (>= 2.3~),
               libastyle-dev (>= 3.1),
               libboost-dev (>= 1.35.0~),
               libclang-dev,
               libkf6archive-dev (>= 6.0.0~),
               libkf6config-dev (>= 6.0.0~),
               libkf6crash-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6iconthemes-dev (>= 6.0.0~),
               libkf6itemmodels-dev (>= 6.0.0~),
               libkf6itemviews-dev (>= 6.0.0~),
               libkf6jobwidgets-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6newstuff-dev (>= 6.0.0~),
               libkf6notifications-dev (>= 6.0.0~),
               libkf6notifyconfig-dev (>= 6.0.0~),
               libkf6parts-dev (>= 6.0.0~),
               libkf6purpose-dev,
               libkf6runner-dev,
               libkf6service-dev (>= 6.0.0~),
               libkf6sonnet-dev (>= 6.0.0~),
               libkf6texteditor-dev (>= 6.0.0~),
               libkf6texttemplate-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libkf6threadweaver-dev (>= 6.0.0~),
               libkf6windowsystem-dev (>= 6.0.0~),
               libkf6xmlgui-dev (>= 6.0.0~),
               libkomparediff2-dev (>= 4:25.08.2~),
               libksysguard-dev,
               libplasma-dev,
               libsvn-dev,
               llvm-dev,
               pkgconf,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-tools-dev,
               qt6-webengine-dev,
               shared-mime-info (>= 1.9~),
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.kdevelop.org/
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop

Package: kdevelop63-libs
Section: libs
Architecture: amd64 arm64 armhf
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevelop
Architecture: amd64 arm64 armhf
Depends: kdevelop-data (>= ${source:Version}),
         kdevelop63-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: g++,
            gcc,
            gdb (>= 7.0),
            kapptemplate,
            kio-extras,
            make,
            ${kdevelop:clang},
Suggests: clang,
          clang-tidy,
          clazy,
          cmake (>= 3.16~),
          cppcheck,
          git,
          heaptrack [linux-any],
          kdevelop-l10n,
          konsole,
          meson,
          ninja-build,
Description: integrated development environment for C/C++ and other languages
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 KDevelop has parser backends for C, C++ and Javascript/QML, with further
 external plugins supporting e.g. PHP or Python.

Package: kdevelop-data
Architecture: all
Depends: ${misc:Depends},
Description: data files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains arch independent data for KDevelop.

Package: kdevelop-dev
Section: libdevel
Architecture: amd64 arm64 armhf
Depends: kdevelop63-libs (= ${binary:Version}),
         libboost-dev (>= 1.35.0~),
         libkf6config-dev (>= 6.0.0~),
         libkf6guiaddons-dev (>= 6.0.0~),
         libkf6i18n-dev (>= 6.0.0~),
         libkf6iconthemes-dev (>= 6.0.0~),
         libkf6kio-dev (>= 6.0.0~),
         libkf6parts-dev (>= 6.0.0~),
         libkf6texteditor-dev (>= 6.0.0~),
         libkf6threadweaver-dev (>= 6.0.0~),
         qt6-5compat-dev (>= 6.5.0~),
         qt6-base-dev (>= 6.5.0~),
         qt6-declarative-dev (>= 6.5.0~),
         qt6-webengine-dev,
         ${misc:Depends},
Description: development files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains development files for KDevelop.

Package: kdevelop-l10n
Section: localization
Architecture: all
Depends: ${misc:Depends},
Description: localization files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the translations for KDevelop.

Package: plasma-kdevelop
Architecture: amd64 arm64 armhf
Depends: kdevelop (= ${binary:Version}),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: KDevelop plugins for Plasma
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the KDevelop plugins for integrating in the Plasma
 desktop environment:
  * sessions data engine
  * sessions widget
  * sessions KRunner module

## kdevelop 25.08.2+p24.04+vstable+git20251015.1726

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vstable+git20251015.1726-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Wed, 15 Oct 2025 17:26:26 +0000

kdevelop (4:25.08.2-0neon) noble; urgency=medium

  * New release

 -- Neon CI <neon@kde.org>  Fri, 10 Oct 2025 03:45:04 +0000

## kdevelop 25.08.2+p24.04+vstable+git20251020.0018

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vstable+git20251020.0018-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 00:18:33 +0000

## kdevelop 25.08.2+p24.04+vstable+git20251021.0239

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vstable+git20251021.0239-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 02:39:28 +0000

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Andreas Cord-Landwehr <cola@uni-paderborn.de>
Build-Depends: clazy,
               cmake,
               cppcheck,
               debhelper-compat (= 13),
               heaptrack-gui,
               kdevelop-pg-qt,
               kf6-extra-cmake-modules,
               kf6-kcmutils-dev,
               kf6-kcolorscheme-dev,
               kf6-kconfig-dev,
               kf6-kcrash-dev,
               kf6-kdeclarative-dev,
               kf6-kdoctools-dev,
               kf6-ki18n-dev,
               kf6-kiconthemes-dev,
               kf6-kio-dev,
               kf6-kitemmodels-dev,
               kf6-kitemviews-dev,
               kf6-kjobwidgets-dev,
               kf6-knewstuff-dev,
               kf6-knotifications-dev,
               kf6-knotifyconfig-dev,
               kf6-kparts-dev,
               kf6-krunner-dev [linux-any],
               kf6-kservice-dev,
               kf6-ktexteditor-dev,
               kf6-ktexttemplate-dev,
               kf6-kwindowsystem-dev,
               kf6-kxmlgui-dev,
               kf6-purpose-dev,
               kf6-syntax-highlighting-dev,
               kf6-threadweaver-dev,
               libastyle-dev,
               libboost-dev (>= 1.35.0),
               libclang-19-dev (>= 1:3.8) [!alpha !hppa !hurd-any !ia64 !kfreebsd-any !m68k !powerpcspe !riscv64 !sh4 !x32],
               libcups2-dev,
               libedit-dev,
               libkomparediff2-dev,
               libksysguard-dev,
               libplasma-dev,
               libsvn-dev,
               libzstd-dev,
               llvm-19-dev (>= 1:3.8) [!alpha !hppa !hurd-any !ia64 !kfreebsd-any !m68k !powerpcspe !riscv64 !sh4 !x32],
               okteta-dev,
               pkg-kde-tools-neon,
               qt6-base-dev,
               qt6-declarative-dev,
               qt6-tools-dev,
               qt6-webengine-dev,
               shared-mime-info
Standards-Version: 4.6.2
Homepage: http://www.kdevelop.org/
Vcs-Git: https://invent.kde.org/neon/extras/kdevelop.git
Vcs-Browser: https://invent.kde.org/neon/extras/kdevelop
Maintainer: Neon CI <neon@kde.org>

Package: kdevelop
Architecture: any
Depends: clang-tidy,
         clazy,
         cppcheck,
         heaptrack-gui,
         kdevelop-data (>= ${source:Version}),
         meson,
         ninja-build,
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qt6-webengine,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: g++, gcc, gdb (>= 7.0), kapptemplate, make, plasma-kdevelop
Suggests: cmake, heaptrack
Description: integrated development environment for KDE
 KDevelop is an easy to use integrated development environment for KDE.
 It supports a wide range of programming languages and features project
 management, an advanced editor, a class browser and an integrated debugger.
 .
 KDevelop has parser backends for C, C++ and Javascript/QML, with further
 external plugins supporting e.g. PHP or Python.

Package: kdevelop-dev
Section: libdevel
Architecture: any
Depends: kdevelop (= ${binary:Version}),
         kdevplatform-dev,
         kf6-karchive-dev,
         kf6-kconfigwidgets-dev,
         kf6-ktexteditor-dev,
         kf6-syntax-highlighting-dev,
         ${misc:Depends}
Description: development files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains development files for KDevelop.

Package: kdevelop-data
Architecture: all
Section: oldlibs
Depends: kdevelop, ${misc:Depends}
Description: Dummy transitional package.
 This is a dummy transitional and can be safely deleted.

Package: kdevelop-l10n
Architecture: all
Section: oldlibs
Depends: kdevelop, ${misc:Depends}
Description: Dummy transitional package.
 This is a dummy transitional and can be safely deleted.

Package: kdevplatform-dev
Section: libdevel
Architecture: any
Depends: kdevplatform-libs (= ${binary:Version}),
         kf6-karchive-dev,
         kf6-ktexteditor-dev,
         kf6-threadweaver-dev,
         qt6-base-dev,
         qt6-declarative-dev,
         qt6-webengine-dev,
         ${misc:Depends}
Description: development files for the KDevelop platform
 This package contains development files for building integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevplatform-libs
Architecture: any
Depends: qml6-module-qtquick,
         qml6-module-qtquick-controls,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: kdevplatform515-libs (<< 4:24.08.2)
Provides: qml6-module-org-kde-kdevplatform
Suggests: cvs, git, kdevplatform-l10n, konsole, zsh
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevplatform514-libs
Architecture: all
Section: oldlibs
Depends: kdevplatform-libs, ${misc:Depends}
Description: dummy transitional
 This is a dummy transitional and can be safely deleted.

Package: plasma-kdevelop
Architecture: any
Depends: kdevelop (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: KDevelop plugins for Plasma
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.

## kdevelop 25.08.2+p24.04+vstable+git20251027.0015

=== kdevplatform/CMakeLists.txt ===
# kdevplatform soversion
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVPLATFORM_SOVERSION ${KDEVELOP_SOVERSION})

# Increase this to reset incompatible item-repositories.
# Changing KDevelop's major or minor version automatically resets the itemrepository as well.
set(KDEV_ITEMREPOSITORY_INCREMENT 4)

set(KDevPlatform_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(KDevPlatform_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

set(CMAKE_MODULE_PATH ${KDevPlatform_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevPlatform")

include(KDevPlatformMacros)
include(KDevPlatformMacrosInternal)

set(Boost_ADDITIONAL_VERSIONS 1.39.0 1.39)
find_package(Boost 1.35.0)
set_package_properties(Boost PROPERTIES
    PURPOSE "Boost libraries for enabling the classbrowser"
    URL "https://www.boost.org/"
    TYPE REQUIRED)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/config-kdevplatform.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/config-kdevplatform.h )

include_directories(${KDevPlatform_SOURCE_DIR} ${KDevPlatform_BINARY_DIR})

if(BUILD_TESTING)
  set(KDEV_FIND_DEP_QTTEST "find_dependency(Qt6Test \"${QT_MIN_VERSION}\")")
endif()
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevPlatformConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfig.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX KDEVPLATFORM
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevplatform_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
                  SOVERSION ${KDEVPLATFORM_SOVERSION}
)

add_subdirectory(sublime)
add_subdirectory(interfaces)
add_subdirectory(project)
add_subdirectory(language)
add_subdirectory(shell)
add_subdirectory(util)
add_subdirectory(outputview)
add_subdirectory(vcs)
add_subdirectory(pics)
add_subdirectory(debugger)
add_subdirectory(documentation)
add_subdirectory(serialization)
add_subdirectory(template)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()


install( FILES
        "${KDevPlatform_BINARY_DIR}/kdevplatform_version.h"
        "${KDevPlatform_BINARY_DIR}/config-kdevplatform.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevplatform" )
install( FILES
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfig.cmake"
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
        cmake/modules/KDevPlatformMacros.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install( EXPORT KDevPlatformTargets
         DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
         NAMESPACE KDev::
         FILE KDevPlatformTargets.cmake )

# kdebugsettings file
install_qt_logging_categories(TYPE LIBRARY)

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vstable+git20251027.0015-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 27 Oct 2025 00:15:55 +0000

=== debian/rules ===
#!/usr/bin/make -f
# SPDX-License-Identifier: LGPL-2.0-or-later
# # SPDX-FileCopyrightText: 2023 Jonathan Riddell <jr@jriddell.org>

%:
	dh $@ --with kf6 --buildsystem kf6

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_WITH_QT6=ON

## kdevelop 25.08.2+p24.04+vstable+git20251028.1054

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vstable+git20251028.1054-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 28 Oct 2025 10:54:41 +0000

## kdevelop 25.08.2+p24.04+vstable+git20251031.0255

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vstable+git20251031.0255-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Fri, 31 Oct 2025 02:55:41 +0000

## kdevelop 25.08.2+p24.04+vunstable+git20251020.0341

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 # KDE Gear version, managed by release service script
 set(RELEASE_SERVICE_VERSION_MAJOR "25")
-set(RELEASE_SERVICE_VERSION_MINOR "08")
-set(RELEASE_SERVICE_VERSION_MICRO "2")
+set(RELEASE_SERVICE_VERSION_MINOR "11")
+set(RELEASE_SERVICE_VERSION_MICRO "70")
 
 set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vunstable+git20251020.0341-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Mon, 20 Oct 2025 03:41:39 +0000

## kdevelop 25.08.2+p24.04+vunstable+git20251021.0238

=== debian/changelog ===
kdevelop (4:25.08.2+p24.04+vunstable+git20251021.0238-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Tue, 21 Oct 2025 02:38:49 +0000
